<template>
  <div>
    <div class="answer-background" />
    <v-card
      class="card-answer mx-auto"
      outlined
    >
      <v-list-item three-line>
        <v-list-item-content>
          <div class="icon-jabarsurvey" />
          <v-card-text class="headline">{{ name_survey }}</v-card-text>
          <v-list-item-subtitle class="content-answer">
            <ValidationObserver v-slot="{ validate, reset }" ref="observer">
              <form
                ref="form"
                lazy-validation
              >
                <survey-questions-views
                  :questions-list="questions"
                />
              </form>
            </ValidationObserver>
          </v-list-item-subtitle>
        </v-list-item-content>
      </v-list-item>
      <v-card-actions class="justify-center">
        <v-btn color="success" @click="submitAnswer">{{ $t('label.submit_survey') }}</v-btn>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import { ValidationObserver } from 'vee-validate'
export default {
  name: 'FormAnswer',
  components: {
    ValidationObserver
  },
  data() {
    return {
      name_survey: '',
      questions: [],
      answers: null,
      key_survey: null
    }
  },
  computed: {
    ...mapGetters('survey', [
      'detailSurvey'
    ])
  },
  async created() {
    this.key_survey = this.$route.query && this.$route.query.key
    if (this.key_survey === null) { this.$router.push({ path: this.redirect || '/login' }) }
    await this.$store.dispatch('survey/getSurveyByKey', this.key_survey)
    this.questions = await this.detailSurvey.questions
    this.questions.map(function(el) {
      return Object.assign(el, { answer: [] })
    })
    this.name_survey = await this.detailSurvey.surveys.survey_name
  },
  methods: {
    async submitAnswer() {
      const valid = await this.$refs.observer.validate()
      if (!valid) {
        return
      }
      this.questions.map(function(el) {
        el['id_questions'] = el['id']
        delete el['id']
        delete el['options']
        delete el['description']
        delete el['require']
      })
      const data = {
        key_survey: this.key_survey,
        answer: {
          respondent: this.questions
        }
      }
      try {
        this.$store.dispatch('answerSurvey/saveAnswerSurvey', data)
        this.$store.dispatch('toast/successToast', this.$t('success.survey_answer_success'))
        this.$router.push({ path: '/thanks-response', query: { key: this.key_survey }})
      } catch (e) {
        this.$store.dispatch('toast/errorToast', this.$t('errors.server_error_occurred'))
      }
    }
  }
}
</script>

